import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { ProjectSheetService } from "@yukawa/chain-tracker-angular-core";
import { ProjectSheet, ProjectSheetFilter } from "@yukawa/chain-tracker-angular-core";
export declare class ProjectSheetQueryStore extends QueryTableSource<ProjectSheetFilter, ProjectSheet> {
    protected service: ProjectSheetService;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: any;
    constructor(service: ProjectSheetService, paginator?: MatPaginator, sort?: MatSort, tableFilter?: any);
    protected queryTable(): Observable<any>;
}
