import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { Project, ProjectFilter, ProjectService } from "@yukawa/chain-tracker-angular-core";
export declare class ProjectQueryStore extends QueryTableSource<ProjectFilter, Project> {
    service: ProjectService;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: ProjectFilter;
    constructor(service: ProjectService, paginator?: MatPaginator, sort?: MatSort, tableFilter?: ProjectFilter);
    protected queryTable(): Observable<any>;
}
