import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { DataSource } from '@angular/cdk/collections';
import { MatSort } from "@angular/material/sort";
import { MatPaginator } from '@angular/material/paginator';
import { Project } from "@yukawa/chain-tracker-angular-core";
import { AccountUtilities } from "@yukawa/chain-crm-angular-core";
import { PartnerType } from "@yukawa/chain-crm-angular-core";
import { ProjectPhase } from "@yukawa/chain-tracker-angular-core";
import * as i0 from "@angular/core";
export declare class ProjectTableComponent implements OnInit, OnDestroy {
    displayedColumns: string[];
    customColumns: any[];
    dataSource: DataSource<Project | any>;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    partnerDetailsRowId: string;
    accountUtils: typeof AccountUtilities;
    partnerType: typeof PartnerType;
    constructor();
    ngOnInit(): void;
    /**
     * On destroy
     */
    ngOnDestroy(): void;
    onAction(type: string, project: Project | any): void;
    protected fireAction(action: any): void;
    onOverlayAction(action: string): void;
    getIdHeader(): ProjectPhase;
    static ɵfac: i0.ɵɵFactoryDef<ProjectTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ProjectTableComponent, "chain-tracker-project-table", never, { "displayedColumns": "displayedColumns"; "customColumns": "customColumns"; "dataSource": "dataSource"; }, { "action": "action"; }, never, never>;
}
