import * as i0 from '@angular/core';
import { EventEmitter, isDevMode, Component, ViewEncapsulation, Input, Output, ViewChild, forwardRef, Inject, Directive, ViewChildren, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import * as i5 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import * as i3 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import { AccountUtilities, PartnerType } from '@yukawa/chain-crm-angular-core';
import * as i1 from '@yukawa/chain-tracker-angular-core';
import { ProjectPhase, ProjectSheetService, RiskService, Fep, AttachmentService } from '@yukawa/chain-tracker-angular-core';
import * as i4 from '@angular/material/table';
import { MatTableModule } from '@angular/material/table';
import * as i8 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i5$1 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i3$1 from '@angular/flex-layout/flex';
import * as i7 from '@yukawa/chain-base-angular-comp';
import { ChainBaseComp } from '@yukawa/chain-base-angular-comp';
import * as i8$1 from '@angular/cdk/table';
import { CdkTableModule } from '@angular/cdk/table';
import * as i12 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import { QueryTableSource } from '@yukawa/chain-base-angular-store';
import { BehaviorSubject, fromEvent } from 'rxjs';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';
import * as i2 from '@angular/router';
import { ActivatedRoute } from '@angular/router';
import * as i4$1 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i9 from '@angular/flex-layout/extended';
import * as i11 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i3$2 from '@angular/forms';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i4$2 from '@angular/material/form-field';
import * as i5$2 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i6 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import * as i8$2 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i9$1 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i10 from '@angular/material/core';
import { MatRippleModule } from '@angular/material/core';
import { FlexLayoutModule } from '@angular/flex-layout';
import { HttpClientModule } from '@angular/common/http';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatMenuModule } from '@angular/material/menu';

function ProjectTableComponent_mat_header_cell_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, ctx_r2.getIdHeader()));
} }
function ProjectTableComponent_mat_cell_7_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span", 25);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r33 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("matTooltip", row_r33.phase);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate((row_r33.info == null ? null : row_r33.info.shortName) || row_r33.projectId);
} }
function ProjectTableComponent_mat_header_cell_9_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.ID"));
} }
function ProjectTableComponent_mat_cell_10_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span", 25);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("matTooltip", row_r34.phase);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate((row_r34.info == null ? null : row_r34.info.shortName) || row_r34.projectId);
} }
function ProjectTableComponent_mat_header_cell_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.NAME"));
} }
function ProjectTableComponent_mat_cell_13_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span", 25);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r35 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("matTooltip", row_r35.info == null ? null : row_r35.info.desc);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(row_r35.info == null ? null : row_r35.info.name);
} }
function ProjectTableComponent_mat_header_cell_15_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.CUSTOMER"));
} }
function ProjectTableComponent_mat_cell_16_div_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 27);
    i0.ɵɵelementStart(1, "span", 28);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r36 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r36 == null ? null : row_r36.customer == null ? null : row_r36.customer.companyName);
} }
function ProjectTableComponent_mat_cell_16_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtemplate(1, ProjectTableComponent_mat_cell_16_div_1_Template, 3, 1, "div", 26);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r36 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", row_r36.customer);
} }
function ProjectTableComponent_mat_header_cell_18_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.OWNER"));
} }
function ProjectTableComponent_mat_cell_19_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r40 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r40 == null ? null : row_r40.change == null ? null : row_r40.change.user);
} }
function ProjectTableComponent_mat_header_cell_21_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.HEAD_ENGINEER"));
} }
function ProjectTableComponent_mat_cell_22_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r41 = ctx.$implicit;
    const ctx_r13 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r41.head != null ? ctx_r13.accountUtils.getDisplayName(row_r41.head, ctx_r13.partnerType.PERSON) : "");
} }
function ProjectTableComponent_mat_header_cell_24_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.START_DATE"));
} }
function ProjectTableComponent_mat_cell_25_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 29);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r42 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r42.actualStartDate);
} }
function ProjectTableComponent_mat_header_cell_27_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.END_DATE"));
} }
function ProjectTableComponent_mat_cell_28_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 29);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r43 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r43.actualEndDate);
} }
function ProjectTableComponent_mat_header_cell_30_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.START_DATE"));
} }
function ProjectTableComponent_mat_cell_31_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 29);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r44 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r44.plannedStartDate);
} }
function ProjectTableComponent_mat_header_cell_33_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.END_DATE"));
} }
function ProjectTableComponent_mat_cell_34_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 29);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r45 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r45.plannedEndDate);
} }
function ProjectTableComponent_mat_header_cell_36_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CHANGE_DATE"));
} }
function ProjectTableComponent_mat_cell_37_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 30);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r46 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r46.change == null ? null : row_r46.change.date)("matTooltip", row_r46.change == null ? null : row_r46.change.user);
} }
function ProjectTableComponent_mat_header_cell_39_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.PHASE"));
} }
function ProjectTableComponent_mat_cell_40_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r47 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r47 == null ? null : row_r47.phase);
} }
function ProjectTableComponent_mat_header_cell_42_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.STATUS"));
} }
function ProjectTableComponent_mat_cell_43_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r48 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate1(" ", row_r48.status, " ");
} }
function ProjectTableComponent_mat_header_cell_45_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 24);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.ESTIMATED_VOLUME"));
} }
function ProjectTableComponent_mat_cell_46_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r49 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate((row_r49 == null ? null : row_r49.plannedBudget == null ? null : row_r49.plannedBudget.money) !== null ? row_r49.plannedBudget.money + " \u20AC" : "");
} }
function ProjectTableComponent_ng_container_47_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const column_r50 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r50.header);
} }
function ProjectTableComponent_ng_container_47_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r54 = ctx.$implicit;
    const column_r50 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r50.cell(row_r54));
} }
function ProjectTableComponent_ng_container_47_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0, 31);
    i0.ɵɵtemplate(1, ProjectTableComponent_ng_container_47_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 32);
    i0.ɵɵtemplate(2, ProjectTableComponent_ng_container_47_mat_cell_2_Template, 2, 1, "mat-cell", 33);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r50 = ctx.$implicit;
    i0.ɵɵproperty("cdkColumnDef", column_r50.columnDef);
} }
function ProjectTableComponent_mat_header_row_48_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-row");
} }
function ProjectTableComponent_mat_row_49_Template(rf, ctx) { if (rf & 1) {
    const _r58 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-row", 34);
    i0.ɵɵlistener("click", function ProjectTableComponent_mat_row_49_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r58); const row_r56 = ctx.$implicit; const ctx_r57 = i0.ɵɵnextContext(); return ctx_r57.onAction("edit", row_r56); });
    i0.ɵɵelementEnd();
} }
const _c0$3 = function () { return [5, 10, 25, 100]; };
const TAG$2 = 'ProjectTableComponent';
class ProjectTableComponent {
    constructor() {
        this.displayedColumns = ['projectId', 'phase', 'info.name', 'customer.companyName', 'created.user', 'head', 'actualStartDate', 'actualEndDate', 'plannedBudget.money'];
        this.customColumns = [];
        this.action = new EventEmitter();
        this.accountUtils = AccountUtilities;
        this.partnerType = PartnerType;
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
        }
        else {
        }
    }
    /**
     * On destroy
     */
    ngOnDestroy() {
        this.action.complete();
    }
    onAction(type = "", project) {
        if (isDevMode()) {
            console.debug(TAG$2, "onAction", project);
        }
        event.stopPropagation();
        this.fireAction({ type: type, project: project });
    }
    fireAction(action) {
        this.action.emit(action);
    }
    onOverlayAction(action) {
        if (action === 'close') {
            this.partnerDetailsRowId = "";
        }
    }
    getIdHeader() {
        // return  this.onAction("getIdHeader",null)
        return ProjectPhase.PHASE_LEAD;
        // let phase = this._route.snapshot.params.phase
        // switch (phase) {
        //     case ProjectPhase.PHASE_LEAD:
        //         return "PROJECT.HEADER.LEAD_ID"
        //     case ProjectPhase.PHASE_PROJECT:
        //         return "PROJECT.HEADER.PROJECT_ID"
        //     case ProjectPhase.PHASE_PROPOSAL:
        //         return "PROJECT.HEADER.OPPORTUNITY_ID";
        //     default:
        //         return "PROJECT.HEADER.ID";
        // }
    }
}
/** @nocollapse */ ProjectTableComponent.ɵfac = function ProjectTableComponent_Factory(t) { return new (t || ProjectTableComponent)(); };
/** @nocollapse */ ProjectTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ProjectTableComponent, selectors: [["chain-tracker-project-table"]], viewQuery: function ProjectTableComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵstaticViewQuery(MatPaginator, true);
        i0.ɵɵstaticViewQuery(MatSort, true);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", dataSource: "dataSource" }, outputs: { action: "action" }, decls: 50, vars: 8, consts: [[1, "table-layout-1"], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortActive", "actualStartDate", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "projectId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "info.shortName"], ["matColumnDef", "info.name", 1, "mat-column-info-name"], ["matColumnDef", "customer.companyName"], ["matColumnDef", "created.user", 1, "mat-column-owner"], ["matColumnDef", "head"], ["matColumnDef", "actualStartDate"], ["matColumnDef", "actualEndDate"], ["matColumnDef", "plannedStartDate"], ["matColumnDef", "plannedEndDate"], ["matColumnDef", "changed.date"], ["matColumnDef", "phase"], ["matColumnDef", "status"], ["matColumnDef", "plannedBudget.money"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], ["fxLayoutAlign", "none center", 4, "ngIf"], ["fxLayoutAlign", "none center"], ["fxFlex", "90", 1, "customer-name"], ["format", "day", "formatTip", "false", 3, "data"], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], [3, "click"]], template: function ProjectTableComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵelement(1, "mat-paginator", 1, 2);
        i0.ɵɵelementStart(3, "mat-table", 3, 4);
        i0.ɵɵelementContainerStart(5, 5);
        i0.ɵɵtemplate(6, ProjectTableComponent_mat_header_cell_6_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(7, ProjectTableComponent_mat_cell_7_Template, 3, 2, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(8, 8);
        i0.ɵɵtemplate(9, ProjectTableComponent_mat_header_cell_9_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(10, ProjectTableComponent_mat_cell_10_Template, 3, 2, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(11, 9);
        i0.ɵɵtemplate(12, ProjectTableComponent_mat_header_cell_12_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(13, ProjectTableComponent_mat_cell_13_Template, 3, 2, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(14, 10);
        i0.ɵɵtemplate(15, ProjectTableComponent_mat_header_cell_15_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(16, ProjectTableComponent_mat_cell_16_Template, 2, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(17, 11);
        i0.ɵɵtemplate(18, ProjectTableComponent_mat_header_cell_18_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(19, ProjectTableComponent_mat_cell_19_Template, 3, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(20, 12);
        i0.ɵɵtemplate(21, ProjectTableComponent_mat_header_cell_21_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(22, ProjectTableComponent_mat_cell_22_Template, 3, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(23, 13);
        i0.ɵɵtemplate(24, ProjectTableComponent_mat_header_cell_24_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(25, ProjectTableComponent_mat_cell_25_Template, 2, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(26, 14);
        i0.ɵɵtemplate(27, ProjectTableComponent_mat_header_cell_27_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(28, ProjectTableComponent_mat_cell_28_Template, 2, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(29, 15);
        i0.ɵɵtemplate(30, ProjectTableComponent_mat_header_cell_30_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(31, ProjectTableComponent_mat_cell_31_Template, 2, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(32, 16);
        i0.ɵɵtemplate(33, ProjectTableComponent_mat_header_cell_33_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(34, ProjectTableComponent_mat_cell_34_Template, 2, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(35, 17);
        i0.ɵɵtemplate(36, ProjectTableComponent_mat_header_cell_36_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(37, ProjectTableComponent_mat_cell_37_Template, 2, 2, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(38, 18);
        i0.ɵɵtemplate(39, ProjectTableComponent_mat_header_cell_39_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(40, ProjectTableComponent_mat_cell_40_Template, 3, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(41, 19);
        i0.ɵɵtemplate(42, ProjectTableComponent_mat_header_cell_42_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(43, ProjectTableComponent_mat_cell_43_Template, 2, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(44, 20);
        i0.ɵɵtemplate(45, ProjectTableComponent_mat_header_cell_45_Template, 3, 3, "mat-header-cell", 6);
        i0.ɵɵtemplate(46, ProjectTableComponent_mat_cell_46_Template, 3, 1, "mat-cell", 7);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(47, ProjectTableComponent_ng_container_47_Template, 3, 1, "ng-container", 21);
        i0.ɵɵtemplate(48, ProjectTableComponent_mat_header_row_48_Template, 1, 0, "mat-header-row", 22);
        i0.ɵɵtemplate(49, ProjectTableComponent_mat_row_49_Template, 1, 0, "mat-row", 23);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c0$3));
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("dataSource", ctx.dataSource);
        i0.ɵɵadvance(44);
        i0.ɵɵproperty("ngForOf", ctx.customColumns);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i5$1.MatTooltip, i8.NgIf, i3$1.DefaultLayoutAlignDirective, i3$1.DefaultFlexDirective, i7.BaseDateComponent, i8$1.CdkColumnDef, i8$1.CdkHeaderCellDef, i8$1.CdkCellDef, i4.MatHeaderRow, i4.MatRow], pipes: [i12.TranslatePipe], styles: ["chain-tracker-project-table{width:100%!important}chain-tracker-project-table .mat-table{background:transparent;box-shadow:none}chain-tracker-project-table .mat-table .mat-row{position:relative;cursor:pointer!important;min-height:64px}chain-tracker-project-table .info-icon{padding-right:5px}chain-tracker-project-table .customer-name{margin-right:20px!important}chain-tracker-project-table .mat-column-customer{white-space:unset!important;flex:0 0 18%!important;width:18%!important}chain-tracker-project-table .mat-column-customer,chain-tracker-project-table .mat-column-info-name{overflow-wrap:break-word;word-wrap:break-word;word-break:break-word;-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto}chain-tracker-project-table .mat-column-info-name{white-space:nowrap!important;flex:0 0 15%!important;width:15%!important}chain-tracker-project-table .mat-column-created-user{white-space:unset!important;flex:0 0 12%!important;width:12%!important;overflow-wrap:break-word;word-wrap:break-word;word-break:break-word;-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto}chain-tracker-project-table .mat-column-headEngineer,chain-tracker-project-table .mat-column-plannedBudget-money{white-space:pre-wrap;-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto}chain-tracker-project-table .mat-column-headEngineer{text-align:center}"], encapsulation: 2 });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ProjectTableComponent, [{
        type: Component,
        args: [{
                selector: 'chain-tracker-project-table',
                templateUrl: './project-table.component.html',
                styleUrls: ['./project-table.component.scss'],
                encapsulation: ViewEncapsulation.None
            }]
    }], function () { return []; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], dataSource: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }] }); })();

class ProjectQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    /*
        protected initClientMutations(): any[] {
            return [this.sort.sortChange];
        }


        protected initReloadMutations(): any[] {
            return [this.paginator.page, this.filterSubject]
        }

        protected applySort(filter: TableFilter, sort) {
            super.applySort(filter, sort);
        }
    */
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryProject(filter);
    }
}

class ProjectSheetQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryProjectSheet(filter);
    }
}

const _c0$2 = ["projectsheetfilter"];
function ProjectSheetTableComponent_mat_header_cell_17_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 25);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.REPORT_DATE"), " ");
} }
function ProjectSheetTableComponent_mat_cell_18_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵpipe(3, "date");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r18 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(3, 1, row_r18.reportDate));
} }
function ProjectSheetTableComponent_mat_header_cell_20_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 25);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.NAME"));
} }
function ProjectSheetTableComponent_mat_cell_21_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r19 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r19 == null ? null : row_r19.info == null ? null : row_r19.info.name);
} }
function ProjectSheetTableComponent_mat_header_cell_23_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 25);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.STATUS"));
} }
const _c1$2 = function (a0, a1, a2) { return { "dot-red": a0, "dot-green": a1, "dot-yellow": a2 }; };
function ProjectSheetTableComponent_mat_cell_24_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "span", 26);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r20 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction3(1, _c1$2, row_r20.status == "red", row_r20.status == "green", row_r20.status == "yellow"));
} }
function ProjectSheetTableComponent_mat_header_cell_26_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 25);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.PERCENTAGE"));
} }
function ProjectSheetTableComponent_mat_cell_27_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate1("", row_r21 == null ? null : row_r21.percentageOfCompletion, " %");
} }
function ProjectSheetTableComponent_mat_cell_27_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtemplate(1, ProjectSheetTableComponent_mat_cell_27_span_1_Template, 2, 1, "span", 27);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", row_r21.percentageOfCompletion);
} }
function ProjectSheetTableComponent_mat_header_cell_29_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 25);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.AMOUNT"));
} }
function ProjectSheetTableComponent_mat_cell_30_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r24 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r24 == null ? null : row_r24.budget == null ? null : row_r24.budget.amount);
} }
function ProjectSheetTableComponent_ng_container_31_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const column_r25 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r25.header);
} }
function ProjectSheetTableComponent_ng_container_31_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r29 = ctx.$implicit;
    const column_r25 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r25.cell(row_r29));
} }
function ProjectSheetTableComponent_ng_container_31_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0, 28);
    i0.ɵɵtemplate(1, ProjectSheetTableComponent_ng_container_31_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 29);
    i0.ɵɵtemplate(2, ProjectSheetTableComponent_ng_container_31_mat_cell_2_Template, 2, 1, "mat-cell", 30);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r25 = ctx.$implicit;
    i0.ɵɵproperty("cdkColumnDef", column_r25.columnDef);
} }
function ProjectSheetTableComponent_mat_header_cell_33_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-cell");
} }
function ProjectSheetTableComponent_mat_cell_34_Template(rf, ctx) { if (rf & 1) {
    const _r33 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "button", 31);
    i0.ɵɵlistener("click", function ProjectSheetTableComponent_mat_cell_34_Template_button_click_1_listener() { i0.ɵɵrestoreView(_r33); const row_r31 = ctx.$implicit; const ctx_r32 = i0.ɵɵnextContext(); return ctx_r32.onAction("delete", row_r31); });
    i0.ɵɵelementStart(2, "mat-icon", 32);
    i0.ɵɵtext(3, " delete ");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} }
function ProjectSheetTableComponent_mat_header_row_35_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-row");
} }
function ProjectSheetTableComponent_mat_row_36_Template(rf, ctx) { if (rf & 1) {
    const _r36 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-row", 33);
    i0.ɵɵlistener("click", function ProjectSheetTableComponent_mat_row_36_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r36); const row_r34 = ctx.$implicit; const ctx_r35 = i0.ɵɵnextContext(); return ctx_r35.onAction("edit", row_r34); });
    i0.ɵɵelementEnd();
} }
const _c2 = function () { return [5, 10, 25, 100]; };
const _c3 = ["*"];
const TAG$1 = "ProjectSheetTableComponent";
class ProjectSheetTableComponent {
    constructor(service, _route) {
        this.service = service;
        this._route = _route;
        // routeAnimationsElements = ROUTE_ANIMATIONS_ELEMENTS;
        this.displayedColumns = ['reportDate', 'status', 'percentageOfCompletion', 'budget.amount'];
        this.customColumns = [];
        this.projectSheetFilter = { type: null, projectId: null };
        this.action = new EventEmitter();
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
            this.displayedColumns.push("action");
        }
        else {
            this.displayedColumns.push("action");
        }
        this._route.params.pipe().subscribe((params) => {
            this.projectSheetFilter.projectId = params.projectId;
            this.dataSource = new ProjectSheetQueryStore(this.service, this.paginator, this.sort, this.projectSheetFilter);
            fromEvent(this.filter.nativeElement, 'keyup')
                .pipe(debounceTime(1000), distinctUntilChanged())
                .subscribe(event => {
                let value = this.filter.nativeElement.value;
                if (value == '')
                    value = null;
                let filter = this.dataSource.filterSubject.value;
                filter.keyword = value;
                this.applyFilter(filter);
            });
        });
    }
    ngOnDestroy() {
        this.action.complete();
    }
    reload(keyword = null) {
        if (keyword)
            this.projectSheetFilter.keyword = keyword;
        this.applyFilter(this.projectSheetFilter);
    }
    applyFilter(filter) {
        this.dataSource.filterSubject.next(filter);
    }
    onAction(type = "", projectSheet) {
        if (isDevMode()) {
            console.debug(TAG$1, "onAction", projectSheet);
        }
        event.stopPropagation();
        this.fireAction({ type: type, projectSheet: projectSheet });
    }
    fireAction(action) {
        this.action.emit(action);
    }
}
/** @nocollapse */ ProjectSheetTableComponent.ɵfac = function ProjectSheetTableComponent_Factory(t) { return new (t || ProjectSheetTableComponent)(i0.ɵɵdirectiveInject(forwardRef(() => ProjectSheetService)), i0.ɵɵdirectiveInject(forwardRef(() => ActivatedRoute))); };
/** @nocollapse */ ProjectSheetTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ProjectSheetTableComponent, selectors: [["chain-project-sheet-table"]], viewQuery: function ProjectSheetTableComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵstaticViewQuery(MatPaginator, true);
        i0.ɵɵstaticViewQuery(MatSort, true);
        i0.ɵɵstaticViewQuery(_c0$2, true);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.filter = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", projectSheetFilter: "projectSheetFilter" }, outputs: { action: "action" }, ngContentSelectors: _c3, decls: 37, vars: 8, consts: [["fxLayout", "row", "fxLayoutAlign", "space-between center", 1, ""], ["fxLayout", "row", "fxLayoutAlign", "space-between center", "fxFlex", ""], [1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["projectsheetfilter", ""], ["type", "submit"], [1, ""], ["fxFlex", "30", 3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], [1, "table-layout-1"], ["matSort", "", "matSortActive", "reportDate", "matSortDirection", "desc", "matSortDisableClear", "", 3, "dataSource"], ["table", ""], ["matColumnDef", "reportDate"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "info.name"], ["matColumnDef", "status"], ["matColumnDef", "percentageOfCompletion"], ["matColumnDef", "budget.amount"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "action"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [1, "dot", 3, "ngClass"], [4, "ngIf"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-button", "", 3, "click"], ["color", "warn"], [3, "click"]], template: function ProjectSheetTableComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "mat-toolbar", 0);
        i0.ɵɵelementStart(1, "div", 1);
        i0.ɵɵprojection(2);
        i0.ɵɵelementStart(3, "div", 2);
        i0.ɵɵelementStart(4, "div", 3);
        i0.ɵɵelement(5, "input", 4, 5);
        i0.ɵɵelementStart(7, "button", 6);
        i0.ɵɵelementStart(8, "i", 7);
        i0.ɵɵelementStart(9, "mat-icon");
        i0.ɵɵtext(10, " search ");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelement(11, "mat-paginator", 8, 9);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(13, "div", 10);
        i0.ɵɵelementStart(14, "mat-table", 11, 12);
        i0.ɵɵelementContainerStart(16, 13);
        i0.ɵɵtemplate(17, ProjectSheetTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 14);
        i0.ɵɵtemplate(18, ProjectSheetTableComponent_mat_cell_18_Template, 4, 3, "mat-cell", 15);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(19, 16);
        i0.ɵɵtemplate(20, ProjectSheetTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 14);
        i0.ɵɵtemplate(21, ProjectSheetTableComponent_mat_cell_21_Template, 3, 1, "mat-cell", 15);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(22, 17);
        i0.ɵɵtemplate(23, ProjectSheetTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 14);
        i0.ɵɵtemplate(24, ProjectSheetTableComponent_mat_cell_24_Template, 2, 5, "mat-cell", 15);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(25, 18);
        i0.ɵɵtemplate(26, ProjectSheetTableComponent_mat_header_cell_26_Template, 3, 3, "mat-header-cell", 14);
        i0.ɵɵtemplate(27, ProjectSheetTableComponent_mat_cell_27_Template, 2, 1, "mat-cell", 15);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(28, 19);
        i0.ɵɵtemplate(29, ProjectSheetTableComponent_mat_header_cell_29_Template, 3, 3, "mat-header-cell", 14);
        i0.ɵɵtemplate(30, ProjectSheetTableComponent_mat_cell_30_Template, 3, 1, "mat-cell", 15);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(31, ProjectSheetTableComponent_ng_container_31_Template, 3, 1, "ng-container", 20);
        i0.ɵɵelementContainerStart(32, 21);
        i0.ɵɵtemplate(33, ProjectSheetTableComponent_mat_header_cell_33_Template, 1, 0, "mat-header-cell", 22);
        i0.ɵɵtemplate(34, ProjectSheetTableComponent_mat_cell_34_Template, 4, 0, "mat-cell", 15);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(35, ProjectSheetTableComponent_mat_header_row_35_Template, 1, 0, "mat-header-row", 23);
        i0.ɵɵtemplate(36, ProjectSheetTableComponent_mat_row_36_Template, 1, 0, "mat-row", 24);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(11);
        i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c2));
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("dataSource", ctx.dataSource);
        i0.ɵɵadvance(17);
        i0.ɵɵproperty("ngForOf", ctx.customColumns);
        i0.ɵɵadvance(4);
        i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [i3$1.DefaultLayoutDirective, i3$1.DefaultLayoutAlignDirective, i3$1.DefaultFlexDirective, i4$1.MatIcon, i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i8.NgClass, i9.DefaultClassDirective, i8.NgIf, i8$1.CdkColumnDef, i8$1.CdkHeaderCellDef, i8$1.CdkCellDef, i11.MatButton, i4.MatHeaderRow, i4.MatRow], pipes: [i12.TranslatePipe, i8.DatePipe], styles: ["chain-project-sheet-table{width:100%}chain-project-sheet-table .mat-table{background:transparent;box-shadow:none}chain-project-sheet-table .mat-table .mat-row{position:relative;cursor:pointer;min-height:64px}.dot{height:20px!important;width:20px!important;border-radius:50%;display:inline-block;margin-left:40px}.dot-red{background-color:red}.dot-green{background-color:green}.dot-yellow{background-color:#ff0}"], encapsulation: 2 });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ProjectSheetTableComponent, [{
        type: Component,
        args: [{
                selector: 'chain-project-sheet-table',
                templateUrl: './project-sheet-table.component.html',
                styleUrls: ['./project-sheet-table.component.scss'],
                encapsulation: ViewEncapsulation.None
            }]
    }], function () { return [{ type: i1.ProjectSheetService, decorators: [{
                type: Inject,
                args: [forwardRef(() => ProjectSheetService)]
            }] }, { type: i2.ActivatedRoute, decorators: [{
                type: Inject,
                args: [forwardRef(() => ActivatedRoute)]
            }] }]; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], projectSheetFilter: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }], filter: [{
            type: ViewChild,
            args: ['projectsheetfilter', { static: true }]
        }] }); })();

class RisksTableQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryRisks(filter);
    }
}

function RisksTableComponent_mat_header_cell_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 19);
    i0.ɵɵtext(1, "Risk Id");
    i0.ɵɵelementEnd();
} }
function RisksTableComponent_mat_cell_9_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r19 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r19 == null ? null : row_r19.riskId);
} }
function RisksTableComponent_mat_header_cell_11_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 19);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.RISK.NAME"));
} }
function RisksTableComponent_mat_cell_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r20 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r20 == null ? null : row_r20.name);
} }
function RisksTableComponent_mat_header_cell_14_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 19);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.MITIGATION"));
} }
function RisksTableComponent_mat_cell_15_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r21 == null ? null : row_r21.mitigation);
} }
function RisksTableComponent_mat_header_cell_17_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 19);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.RISKS.SEVERITY"));
} }
function RisksTableComponent_mat_cell_18_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r22 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r22 == null ? null : row_r22.severity);
} }
function RisksTableComponent_mat_header_cell_20_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 19);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.PROBABILITY"));
} }
function RisksTableComponent_mat_cell_21_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r23 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate((row_r23 == null ? null : row_r23.probability) + "%");
} }
function RisksTableComponent_mat_cell_21_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtemplate(1, RisksTableComponent_mat_cell_21_span_1_Template, 2, 1, "span", 20);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r23 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", row_r23.probability);
} }
function RisksTableComponent_mat_header_cell_23_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 19);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.RISKS.STATUS"));
} }
function RisksTableComponent_mat_cell_24_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r26 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r26 == null ? null : row_r26.status);
} }
function RisksTableComponent_ng_container_25_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const column_r27 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r27.header);
} }
function RisksTableComponent_ng_container_25_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r31 = ctx.$implicit;
    const column_r27 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r27.cell(row_r31));
} }
function RisksTableComponent_ng_container_25_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0, 21);
    i0.ɵɵtemplate(1, RisksTableComponent_ng_container_25_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 22);
    i0.ɵɵtemplate(2, RisksTableComponent_ng_container_25_mat_cell_2_Template, 2, 1, "mat-cell", 23);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r27 = ctx.$implicit;
    i0.ɵɵproperty("cdkColumnDef", column_r27.columnDef);
} }
function RisksTableComponent_mat_header_cell_27_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-cell");
} }
function RisksTableComponent_mat_cell_28_Template(rf, ctx) { if (rf & 1) {
    const _r35 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "button", 24);
    i0.ɵɵlistener("click", function RisksTableComponent_mat_cell_28_Template_button_click_1_listener($event) { i0.ɵɵrestoreView(_r35); const row_r33 = ctx.$implicit; const ctx_r34 = i0.ɵɵnextContext(); ctx_r34.deleteRisk(row_r33.riskId); return $event.stopPropagation(); });
    i0.ɵɵelementStart(2, "mat-icon", 25);
    i0.ɵɵtext(3, " delete ");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} }
function RisksTableComponent_mat_header_row_29_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-row");
} }
function RisksTableComponent_mat_row_30_Template(rf, ctx) { if (rf & 1) {
    const _r38 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-row", 26);
    i0.ɵɵlistener("click", function RisksTableComponent_mat_row_30_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r38); const row_r36 = ctx.$implicit; const ctx_r37 = i0.ɵɵnextContext(); return ctx_r37.onAction("edit", row_r36); });
    i0.ɵɵelementEnd();
} }
const _c0$1 = function () { return [5, 10, 25, 100]; };
const _c1$1 = ["*"];
class RisksTableComponent {
    constructor(_riskService) {
        this._riskService = _riskService;
        this.displayedColumns = ['name', 'mitigation', 'severity', 'probability', 'status'];
        this.customColumns = [];
        this.action = new EventEmitter();
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
            this.displayedColumns.push("actions");
        }
        else {
            this.displayedColumns.push("actions");
        }
        let filter = {};
        //TODO change this when RisksFilter is exposd GK
        filter['projectId'] = this.projectId;
        if (!this.dataSource) {
            this.dataSource = new RisksTableQueryStore(this._riskService, this.paginator, this.sort, filter);
        }
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
    deleteRisk(event) {
        this.onAction('delete', { riskId: event });
    }
}
/** @nocollapse */ RisksTableComponent.ɵfac = function RisksTableComponent_Factory(t) { return new (t || RisksTableComponent)(i0.ɵɵdirectiveInject(forwardRef(() => RiskService))); };
/** @nocollapse */ RisksTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: RisksTableComponent, selectors: [["chain-app-risks-table"]], viewQuery: function RisksTableComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵstaticViewQuery(MatPaginator, true);
        i0.ɵɵstaticViewQuery(MatSort, true);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", projectId: "projectId", dataSource: "dataSource" }, outputs: { action: "action" }, ngContentSelectors: _c1$1, decls: 31, vars: 8, consts: [[1, "table-layout-1"], ["fxLayoutAlign", "space-between center", 1, ""], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "riskId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "name"], ["matColumnDef", "mitigation"], ["matColumnDef", "severity"], ["matColumnDef", "probability"], ["matColumnDef", "status"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "actions"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [4, "ngIf"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-button", "", 3, "click"], ["color", "warn", 1, ""], [3, "click"]], template: function RisksTableComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵelementStart(1, "mat-toolbar", 1);
        i0.ɵɵprojection(2);
        i0.ɵɵelement(3, "mat-paginator", 2, 3);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(5, "mat-table", 4, 5);
        i0.ɵɵelementContainerStart(7, 6);
        i0.ɵɵtemplate(8, RisksTableComponent_mat_header_cell_8_Template, 2, 0, "mat-header-cell", 7);
        i0.ɵɵtemplate(9, RisksTableComponent_mat_cell_9_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(10, 9);
        i0.ɵɵtemplate(11, RisksTableComponent_mat_header_cell_11_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(12, RisksTableComponent_mat_cell_12_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(13, 10);
        i0.ɵɵtemplate(14, RisksTableComponent_mat_header_cell_14_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(15, RisksTableComponent_mat_cell_15_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(16, 11);
        i0.ɵɵtemplate(17, RisksTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(18, RisksTableComponent_mat_cell_18_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(19, 12);
        i0.ɵɵtemplate(20, RisksTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(21, RisksTableComponent_mat_cell_21_Template, 2, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(22, 13);
        i0.ɵɵtemplate(23, RisksTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(24, RisksTableComponent_mat_cell_24_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(25, RisksTableComponent_ng_container_25_Template, 3, 1, "ng-container", 14);
        i0.ɵɵelementContainerStart(26, 15);
        i0.ɵɵtemplate(27, RisksTableComponent_mat_header_cell_27_Template, 1, 0, "mat-header-cell", 16);
        i0.ɵɵtemplate(28, RisksTableComponent_mat_cell_28_Template, 4, 0, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(29, RisksTableComponent_mat_header_row_29_Template, 1, 0, "mat-header-row", 17);
        i0.ɵɵtemplate(30, RisksTableComponent_mat_row_30_Template, 1, 0, "mat-row", 18);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c0$1));
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("dataSource", ctx.dataSource);
        i0.ɵɵadvance(20);
        i0.ɵɵproperty("ngForOf", ctx.customColumns);
        i0.ɵɵadvance(4);
        i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [i3$1.DefaultLayoutAlignDirective, i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i8.NgIf, i8$1.CdkColumnDef, i8$1.CdkHeaderCellDef, i8$1.CdkCellDef, i11.MatButton, i4$1.MatIcon, i4.MatHeaderRow, i4.MatRow], pipes: [i12.TranslatePipe], styles: [""] });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(RisksTableComponent, [{
        type: Component,
        args: [{
                selector: 'chain-app-risks-table',
                templateUrl: './risks-table.component.html',
                styleUrls: ['./risks-table.component.scss']
            }]
    }], function () { return [{ type: i1.RiskService, decorators: [{
                type: Inject,
                args: [forwardRef(() => RiskService)]
            }] }]; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], projectId: [{
            type: Input
        }], dataSource: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }] }); })();

class TemplateIdDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
/** @nocollapse */ TemplateIdDirective.ɵfac = function TemplateIdDirective_Factory(t) { return new (t || TemplateIdDirective)(i0.ɵɵdirectiveInject(i0.TemplateRef)); };
/** @nocollapse */ TemplateIdDirective.ɵdir = i0.ɵɵdefineDirective({ type: TemplateIdDirective, selectors: [["", "templateId", ""]], inputs: { templateId: "templateId" } });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TemplateIdDirective, [{
        type: Directive,
        args: [{
                selector: '[templateId]'
            }]
    }], function () { return [{ type: i0.TemplateRef }]; }, { templateId: [{
            type: Input
        }] }); })();

function CustomFieldComponent_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 13);
    i0.ɵɵelementStart(1, "mat-label");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelement(3, "input", 14);
    i0.ɵɵelement(4, "mat-datepicker-toggle", 15);
    i0.ɵɵelement(5, "mat-datepicker", null, 16);
    i0.ɵɵelement(7, "span", 17);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const _r13 = i0.ɵɵreference(6);
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("formGroup", ctx_r1.formGroup);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1("", ctx_r1.customField.name, " ");
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("matDatepicker", _r13)("name", ctx_r1.customField.name);
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("for", _r13);
} }
function CustomFieldComponent_ng_template_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 13);
    i0.ɵɵelementStart(1, "mat-label");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelement(3, "input", 18);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵproperty("formGroup", ctx_r3.formGroup);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(ctx_r3.customField == null ? null : ctx_r3.customField.name);
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("name", ctx_r3.customField.name);
} }
function CustomFieldComponent_ng_template_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 13);
    i0.ɵɵelementStart(1, "mat-label");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelement(3, "input", 19);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r5 = i0.ɵɵnextContext();
    i0.ɵɵproperty("formGroup", ctx_r5.formGroup);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(ctx_r5.customField == null ? null : ctx_r5.customField.name);
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("name", ctx_r5.customField.name);
} }
function CustomFieldComponent_ng_template_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 13);
    i0.ɵɵelementStart(1, "mat-label");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelement(3, "input", 20);
    i0.ɵɵelementStart(4, "mat-icon", 21);
    i0.ɵɵtext(5, " euro_symbol ");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r7 = i0.ɵɵnextContext();
    i0.ɵɵproperty("formGroup", ctx_r7.formGroup);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", ctx_r7.customField == null ? null : ctx_r7.customField.name, " ");
    i0.ɵɵadvance(1);
    i0.ɵɵpropertyInterpolate("name", ctx_r7.customField == null ? null : ctx_r7.customField.name);
} }
function CustomFieldComponent_ng_template_8_Template(rf, ctx) { if (rf & 1) {
    const _r15 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 22);
    i0.ɵɵelementStart(1, "mat-checkbox", 23);
    i0.ɵɵlistener("ngModelChange", function CustomFieldComponent_ng_template_8_Template_mat_checkbox_ngModelChange_1_listener($event) { i0.ɵɵrestoreView(_r15); const ctx_r14 = i0.ɵɵnextContext(); return ctx_r14.checkboxActive = $event; })("change", function CustomFieldComponent_ng_template_8_Template_mat_checkbox_change_1_listener($event) { i0.ɵɵrestoreView(_r15); const ctx_r16 = i0.ɵɵnextContext(); return ctx_r16.onCheckBoxChange($event); });
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r9 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngModel", ctx_r9.checkboxActive);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r9.customField == null ? null : ctx_r9.customField.name);
} }
function CustomFieldComponent_ng_template_10_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 13);
    i0.ɵɵelementStart(1, "mat-label");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelement(3, "input", 20);
    i0.ɵɵelementStart(4, "mat-icon", 24);
    i0.ɵɵelementStart(5, "span", 25);
    i0.ɵɵtext(6, " % ");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r11 = i0.ɵɵnextContext();
    i0.ɵɵproperty("formGroup", ctx_r11.formGroup);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", ctx_r11.customField == null ? null : ctx_r11.customField.name, " ");
    i0.ɵɵadvance(1);
    i0.ɵɵpropertyInterpolate("name", ctx_r11.customField == null ? null : ctx_r11.customField.name);
} }
function CustomFieldComponent_ng_template_12_mat_option_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-option", 30);
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const option_r19 = ctx.$implicit;
    i0.ɵɵproperty("value", option_r19);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(option_r19);
} }
function CustomFieldComponent_ng_template_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 26, 27);
    i0.ɵɵelementStart(2, "mat-label");
    i0.ɵɵtext(3);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(4, "mat-select", 28);
    i0.ɵɵtemplate(5, CustomFieldComponent_ng_template_12_mat_option_5_Template, 3, 2, "mat-option", 29);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r12 = i0.ɵɵnextContext();
    let tmp_2_0 = null;
    i0.ɵɵproperty("formGroup", ctx_r12.formGroup);
    i0.ɵɵadvance(3);
    i0.ɵɵtextInterpolate(ctx_r12.customField == null ? null : ctx_r12.customField.name);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngForOf", (tmp_2_0 = ctx_r12.formGroup.get("options")) == null ? null : tmp_2_0.value);
} }
class CustomFieldComponent {
    constructor(ref) {
        this.ref = ref;
        this.checkboxActive = false;
        this.options = [];
    }
    ngOnInit() {
    }
    ngAfterContentInit() {
    }
    ngAfterViewInit() {
        let customFieldTemplate = this.templates.toArray().find(val => val.templateId === this.customField.type);
        if (!this.customFieldTemplate) {
            this.customFieldTemplate = customFieldTemplate.templateRef;
            this.ref.detectChanges();
        }
        switch (customFieldTemplate.templateId) {
            case 'boolean':
                this.checkboxActive = this.formGroup.get('value').value === 'true';
                break;
            case 'combobox':
                this.initOptions();
                break;
        }
        this.ref.detectChanges();
    }
    onCheckBoxChange(event) {
        this.formGroup.get('value').patchValue(event.checked.toString());
        this.formGroup.markAsDirty();
    }
    initOptions() {
        this.options = this.customField.options;
    }
}
/** @nocollapse */ CustomFieldComponent.ɵfac = function CustomFieldComponent_Factory(t) { return new (t || CustomFieldComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
/** @nocollapse */ CustomFieldComponent.ɵcmp = i0.ɵɵdefineComponent({ type: CustomFieldComponent, selectors: [["chain-tracker-custom-field"]], viewQuery: function CustomFieldComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(TemplateIdDirective, true);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.templates = _t);
    } }, inputs: { customField: "customField", customFieldTemplate: "customFieldTemplate", formGroup: "formGroup" }, decls: 15, vars: 1, consts: [["templateId", "date"], ["date", ""], ["templateId", "text"], ["text", ""], ["templateId", "number"], ["templateId", "money"], ["money", ""], ["templateId", "boolean"], ["boolean", ""], ["templateId", "percent"], ["percent", ""], ["templateId", "combobox"], [3, "ngTemplateOutlet"], ["appearance", "outline", "floatLabel", "always", 1, "field-wrap", 3, "formGroup"], ["matInput", "", "formControlName", "value", 3, "matDatepicker", "name"], ["matSuffix", "", 3, "for"], ["picker", ""], ["matSuffix", ""], ["matInput", "", "type", "text", "formControlName", "value", 3, "name"], ["matInput", "", "type", "number", "formControlName", "value", 3, "name"], ["type", "number", "matInput", "", "placeholder", "", "formControlName", "value", 3, "name"], [1, ""], [1, "field-wrap"], [3, "ngModel", "ngModelChange", "change"], [2, "font-weight", "bolder", "line-height", "35px"], [2, "padding-bottom", "100px !important"], ["appearance", "outline", 1, "field-wrap", 3, "formGroup"], ["combobox", ""], ["formControlName", "value"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"]], template: function CustomFieldComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵtemplate(0, CustomFieldComponent_ng_template_0_Template, 8, 5, "ng-template", 0, 1, i0.ɵɵtemplateRefExtractor);
        i0.ɵɵtemplate(2, CustomFieldComponent_ng_template_2_Template, 4, 3, "ng-template", 2, 3, i0.ɵɵtemplateRefExtractor);
        i0.ɵɵtemplate(4, CustomFieldComponent_ng_template_4_Template, 4, 3, "ng-template", 4, 3, i0.ɵɵtemplateRefExtractor);
        i0.ɵɵtemplate(6, CustomFieldComponent_ng_template_6_Template, 6, 3, "ng-template", 5, 6, i0.ɵɵtemplateRefExtractor);
        i0.ɵɵtemplate(8, CustomFieldComponent_ng_template_8_Template, 3, 2, "ng-template", 7, 8, i0.ɵɵtemplateRefExtractor);
        i0.ɵɵtemplate(10, CustomFieldComponent_ng_template_10_Template, 7, 3, "ng-template", 9, 10, i0.ɵɵtemplateRefExtractor);
        i0.ɵɵtemplate(12, CustomFieldComponent_ng_template_12_Template, 6, 3, "ng-template", 11);
        i0.ɵɵelementContainerStart(13);
        i0.ɵɵelementContainer(14, 12);
        i0.ɵɵelementContainerEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(14);
        i0.ɵɵproperty("ngTemplateOutlet", ctx.customFieldTemplate);
    } }, directives: [TemplateIdDirective, i8.NgTemplateOutlet, i3$2.NgControlStatusGroup, i3$2.FormGroupDirective, i4$2.MatLabel, i5$2.MatInput, i3$2.DefaultValueAccessor, i6.MatDatepickerInput, i3$2.NgControlStatus, i3$2.FormControlName, i6.MatDatepickerToggle, i4$2.MatSuffix, i6.MatDatepicker, i3$2.NumberValueAccessor, i4$1.MatIcon, i8$2.MatCheckbox, i3$2.NgModel, i9$1.MatSelect, i8.NgForOf, i10.MatOption], styles: [""] });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(CustomFieldComponent, [{
        type: Component,
        args: [{
                selector: 'chain-tracker-custom-field',
                templateUrl: './custom-field.component.html',
                styleUrls: ['./custom-field.component.css']
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { customField: [{
            type: Input
        }], customFieldTemplate: [{
            type: Input
        }], formGroup: [{
            type: Input
        }], templates: [{
            type: ViewChildren,
            args: [TemplateIdDirective]
        }] }); })();

function AddressComponent_mat_option_33_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-option", 15);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const country_r1 = ctx.$implicit;
    i0.ɵɵproperty("value", country_r1.iso);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate2(" ", country_r1.name, " (", country_r1.iso, ") ");
} }
class AddressComponent {
    constructor() {
        this.countries = [];
    }
    ngOnInit() {
    }
}
/** @nocollapse */ AddressComponent.ɵfac = function AddressComponent_Factory(t) { return new (t || AddressComponent)(); };
/** @nocollapse */ AddressComponent.ɵcmp = i0.ɵɵdefineComponent({ type: AddressComponent, selectors: [["chain-app-address"]], inputs: { formGroup: "formGroup", countries: "countries" }, decls: 34, vars: 17, consts: [[3, "formGroup"], [1, "form-row"], [1, "col65"], ["appearance", "outline", "floatLabel", "always", 1, "field-wrap"], ["matInput", "", "formControlName", "street", "name", "firstName"], [1, "col33"], ["matInput", "", "formControlName", "houseNumber"], [1, "col20"], ["matInput", "", "formControlName", "zipCode"], [1, "col50"], ["matInput", "", "formControlName", "city", "name", "firstName"], [1, "col30"], [1, "field-wrap"], ["ngDefaultControl", "", "formControlName", "countryCode", "name", "countryCode"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"]], template: function AddressComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "form", 0);
        i0.ɵɵelementStart(1, "div", 1);
        i0.ɵɵelementStart(2, "div", 2);
        i0.ɵɵelementStart(3, "div", 3);
        i0.ɵɵelementStart(4, "mat-label");
        i0.ɵɵtext(5);
        i0.ɵɵpipe(6, "translate");
        i0.ɵɵelementEnd();
        i0.ɵɵelement(7, "input", 4);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(8, "div", 5);
        i0.ɵɵelementStart(9, "div", 3);
        i0.ɵɵelementStart(10, "mat-label");
        i0.ɵɵtext(11);
        i0.ɵɵpipe(12, "translate");
        i0.ɵɵelementEnd();
        i0.ɵɵelement(13, "input", 6);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(14, "div", 1);
        i0.ɵɵelementStart(15, "div", 7);
        i0.ɵɵelementStart(16, "div", 3);
        i0.ɵɵelementStart(17, "mat-label");
        i0.ɵɵtext(18);
        i0.ɵɵpipe(19, "translate");
        i0.ɵɵelementEnd();
        i0.ɵɵelement(20, "input", 8);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(21, "div", 9);
        i0.ɵɵelementStart(22, "div", 3);
        i0.ɵɵelementStart(23, "mat-label");
        i0.ɵɵtext(24);
        i0.ɵɵpipe(25, "translate");
        i0.ɵɵelementEnd();
        i0.ɵɵelement(26, "input", 10);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(27, "div", 11);
        i0.ɵɵelementStart(28, "div", 12);
        i0.ɵɵelementStart(29, "mat-label");
        i0.ɵɵtext(30);
        i0.ɵɵpipe(31, "translate");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(32, "mat-select", 13);
        i0.ɵɵtemplate(33, AddressComponent_mat_option_33_Template, 2, 3, "mat-option", 14);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵproperty("formGroup", ctx.formGroup);
        i0.ɵɵadvance(5);
        i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(6, 7, "ADDRESS.STREET"), " ");
        i0.ɵɵadvance(6);
        i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(12, 9, "ADDRESS.STREET_NUMBER"), " ");
        i0.ɵɵadvance(7);
        i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(19, 11, "ADDRESS.POST_CODE"), " ");
        i0.ɵɵadvance(6);
        i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(25, 13, "ADDRESS.CITY"), " ");
        i0.ɵɵadvance(6);
        i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(31, 15, "ADDRESS.COUNTRY"), " ");
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("ngForOf", ctx.countries);
    } }, directives: [i3$2.ɵangular_packages_forms_forms_y, i3$2.NgControlStatusGroup, i3$2.FormGroupDirective, i4$2.MatLabel, i5$2.MatInput, i3$2.DefaultValueAccessor, i3$2.NgControlStatus, i3$2.FormControlName, i9$1.MatSelect, i8.NgForOf, i10.MatOption], pipes: [i12.TranslatePipe], styles: [""], encapsulation: 2 });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(AddressComponent, [{
        type: Component,
        args: [{
                selector: 'chain-app-address',
                templateUrl: './address.component.html',
                styleUrls: ['./address.component.scss'],
                encapsulation: ViewEncapsulation.None
            }]
    }], function () { return []; }, { formGroup: [{
            type: Input
        }], countries: [{
            type: Input
        }] }); })();

var AddressType;
(function (AddressType) {
    AddressType["INVOICE"] = "INVOICE";
    AddressType["HOME"] = "HOME";
})(AddressType || (AddressType = {}));
const addressTypes = [];
for (let n in AddressType) {
    addressTypes.push(AddressType[n]);
}

class AttachmentTableQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.query(filter);
    }
}

function AttachmentTableComponent_mat_header_cell_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.ID"));
} }
function AttachmentTableComponent_mat_cell_9_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r21 == null ? null : row_r21.attachmentId);
} }
function AttachmentTableComponent_mat_header_cell_11_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.CATEGORY"));
} }
function AttachmentTableComponent_mat_cell_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r22 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r22 == null ? null : row_r22.category);
} }
function AttachmentTableComponent_mat_header_cell_14_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.NAME"));
} }
function AttachmentTableComponent_mat_cell_15_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r23 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r23.file == null ? null : row_r23.file.fileName);
} }
function AttachmentTableComponent_mat_header_cell_17_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.FILE_SIZE"));
} }
function AttachmentTableComponent_mat_cell_18_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r24 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(row_r24.file == null ? null : row_r24.file.fileSize);
} }
function AttachmentTableComponent_mat_header_cell_20_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "FEP.STATUS"));
} }
function AttachmentTableComponent_mat_cell_21_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelementStart(1, "span", 21);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r25 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("matTooltip", row_r25.fepStatus.userIds);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(row_r25.fepStatus == null ? null : row_r25.fepStatus.status);
} }
function AttachmentTableComponent_mat_header_cell_23_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CREATED_DATE"));
} }
function AttachmentTableComponent_mat_cell_24_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 22);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r26 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r26.created == null ? null : row_r26.created.date)("matTooltip", row_r26.created == null ? null : row_r26.created.user);
} }
function AttachmentTableComponent_mat_header_cell_26_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell", 20);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "translate");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CHANGE_DATE"));
} }
function AttachmentTableComponent_mat_cell_27_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵelement(1, "base-date", 22);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r27 = ctx.$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("data", row_r27.change == null ? null : row_r27.change.date)("matTooltip", row_r27.change == null ? null : row_r27.change.user);
} }
function AttachmentTableComponent_ng_container_28_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-header-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const column_r28 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r28.header);
} }
function AttachmentTableComponent_ng_container_28_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r32 = ctx.$implicit;
    const column_r28 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(column_r28.cell(row_r32));
} }
function AttachmentTableComponent_ng_container_28_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainerStart(0, 23);
    i0.ɵɵtemplate(1, AttachmentTableComponent_ng_container_28_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 24);
    i0.ɵɵtemplate(2, AttachmentTableComponent_ng_container_28_mat_cell_2_Template, 2, 1, "mat-cell", 25);
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r28 = ctx.$implicit;
    i0.ɵɵproperty("cdkColumnDef", column_r28.columnDef);
} }
function AttachmentTableComponent_mat_header_cell_30_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-cell");
} }
function AttachmentTableComponent_mat_cell_31_button_1_Template(rf, ctx) { if (rf & 1) {
    const _r41 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 30);
    i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_1_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r41); const row_r34 = i0.ɵɵnextContext().$implicit; const ctx_r39 = i0.ɵɵnextContext(); ctx_r39.onAction("delete", row_r34); return $event.stopPropagation(); });
    i0.ɵɵelementStart(1, "mat-icon", 31);
    i0.ɵɵtext(2, "delete");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = i0.ɵɵnextContext().$implicit;
    const ctx_r35 = i0.ɵɵnextContext();
    i0.ɵɵpropertyInterpolate("disabled", ctx_r35.isDisabled("delete", row_r34));
} }
function AttachmentTableComponent_mat_cell_31_button_2_Template(rf, ctx) { if (rf & 1) {
    const _r45 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 32);
    i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_2_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r45); const row_r34 = i0.ɵɵnextContext().$implicit; const ctx_r43 = i0.ɵɵnextContext(); ctx_r43.onAction("request", row_r34); return $event.stopPropagation(); });
    i0.ɵɵelementStart(1, "mat-icon", 33);
    i0.ɵɵtext(2, "send");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} }
function AttachmentTableComponent_mat_cell_31_button_3_Template(rf, ctx) { if (rf & 1) {
    const _r48 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 34);
    i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_3_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r48); const row_r34 = i0.ɵɵnextContext().$implicit; const ctx_r46 = i0.ɵɵnextContext(); ctx_r46.onAction("confirm", row_r34); return $event.stopPropagation(); });
    i0.ɵɵelementStart(1, "mat-icon", 33);
    i0.ɵɵtext(2, "check");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = i0.ɵɵnextContext().$implicit;
    const ctx_r37 = i0.ɵɵnextContext();
    i0.ɵɵproperty("disabled", ctx_r37.isDisabled("confirm", row_r34));
} }
function AttachmentTableComponent_mat_cell_31_button_4_Template(rf, ctx) { if (rf & 1) {
    const _r52 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "button", 35);
    i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_4_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r52); const row_r34 = i0.ɵɵnextContext().$implicit; const ctx_r50 = i0.ɵɵnextContext(); ctx_r50.onAction("reject", row_r34); return $event.stopPropagation(); });
    i0.ɵɵelementStart(1, "mat-icon", 33);
    i0.ɵɵtext(2, "backspace");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = i0.ɵɵnextContext().$implicit;
    const ctx_r38 = i0.ɵɵnextContext();
    i0.ɵɵproperty("disabled", ctx_r38.isDisabled("reject", row_r34));
} }
function AttachmentTableComponent_mat_cell_31_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "mat-cell");
    i0.ɵɵtemplate(1, AttachmentTableComponent_mat_cell_31_button_1_Template, 3, 1, "button", 26);
    i0.ɵɵtemplate(2, AttachmentTableComponent_mat_cell_31_button_2_Template, 3, 0, "button", 27);
    i0.ɵɵtemplate(3, AttachmentTableComponent_mat_cell_31_button_3_Template, 3, 1, "button", 28);
    i0.ɵɵtemplate(4, AttachmentTableComponent_mat_cell_31_button_4_Template, 3, 1, "button", 29);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ctx.$implicit;
    const ctx_r18 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", ctx_r18.showAction("delete", row_r34));
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", ctx_r18.showAction("request", row_r34));
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", ctx_r18.showAction("confirm", row_r34));
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("ngIf", ctx_r18.showAction("reject", row_r34));
} }
function AttachmentTableComponent_mat_header_row_32_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "mat-header-row");
} }
function AttachmentTableComponent_mat_row_33_Template(rf, ctx) { if (rf & 1) {
    const _r56 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-row", 36);
    i0.ɵɵlistener("click", function AttachmentTableComponent_mat_row_33_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r56); const row_r54 = ctx.$implicit; const ctx_r55 = i0.ɵɵnextContext(); return ctx_r55.onAction("select", row_r54); });
    i0.ɵɵelementEnd();
} }
const _c0 = function () { return [5, 10, 25, 100]; };
const _c1 = ["*"];
const TAG = 'AttachmentTableComponent';
class AttachmentTableComponent {
    constructor(_service) {
        this._service = _service;
        this.displayedColumns = [
            'file.fileId', 'file.fileName', 'file.fileSize',
            'category', 'change.date', 'fepStatus.status'
        ];
        this.customColumns = [];
        this.showFep = true;
        this.filter = {};
        this.action = new EventEmitter();
        //protected _auth : AuthService
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
            this.displayedColumns.push("actions");
        }
        else {
            this.displayedColumns.push("actions");
        }
        let filter = this.filter;
        if (!this.dataSource) {
            this.dataSource = new AttachmentTableQueryStore(this._service, this.paginator, this.sort, filter);
        }
    }
    reload() {
        this.dataSource.reload();
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
    isDisabled(action, row) {
        if ('delete' == action && row.fepStatus.status && Fep.CONFIRMED == row.fepStatus.status) {
            // @toDo * [ww] check admin
            //console.log(TAG, "isDisabled", this._auth.getUserRoles())
            return false; //!this._auth.isAdmin(); // admin can always delete
        }
        else if ('confirm' == action && row.fepStatus.status && Fep.WAIT_FOR_CONFIRM == row.fepStatus.status) {
            // check if user not already confirmed
            return false; //row.fepStatus.userIds && row.fepStatus.userIds.indexOf(this._auth.getUserName()) !== -1;
        }
        return false;
    }
    showAction(action, row) {
        if (this.displayedActions && this.displayedActions.indexOf(action) == -1)
            return false;
        // @toDo * [ww] check user roles
        if ('delete' == action)
            return true;
        if (['confirm', 'request', 'reject'].indexOf(action) !== -1 && this.showFep && row.fepStatus) {
            let fs = row.fepStatus.status;
            if ('request' == action)
                return false; // never show request for now
            //return Fep.NEW == fs || Fep.REJECTED == fs;
            else if ('confirm' == action)
                return Fep.WAIT_FOR_CONFIRM == fs; //&& this._auth.hasAnyRole([Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM, Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM_PARTIAL]);
            else if ('reject' == action)
                return Fep.WAIT_FOR_CONFIRM == fs; //&& this._auth.hasRole(Yukawa_LeanRealm.ROLE_INVOICE_FEP_REJECT);
        }
        return true;
    }
    showFepButton(action, row) {
        if (!this.showFep || !row.fepStatus)
            return false;
        if ('request' == action)
            return Fep.NEW == row.fepStatus.status || Fep.REJECTED == row.fepStatus.status;
        else if ('confirm' == action || 'reject' == action)
            return Fep.WAIT_FOR_CONFIRM == row.fepStatus.status;
        return false;
    }
}
/** @nocollapse */ AttachmentTableComponent.ɵfac = function AttachmentTableComponent_Factory(t) { return new (t || AttachmentTableComponent)(i0.ɵɵdirectiveInject(forwardRef(() => AttachmentService))); };
/** @nocollapse */ AttachmentTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: AttachmentTableComponent, selectors: [["tracker-attachment-table"]], viewQuery: function AttachmentTableComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵstaticViewQuery(MatPaginator, true);
        i0.ɵɵstaticViewQuery(MatSort, true);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", displayedActions: "displayedActions", showFep: "showFep", filter: "filter", dataSource: "dataSource" }, outputs: { action: "action" }, ngContentSelectors: _c1, decls: 34, vars: 8, consts: [[1, "table-layout-1"], ["fxLayoutAlign", "space-between center", 1, ""], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortActive", "change.date", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "file.fileId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "category"], ["matColumnDef", "file.fileName"], ["matColumnDef", "file.fileSize"], ["matColumnDef", "fepStatus.status"], ["matColumnDef", "created.date"], ["matColumnDef", "change.date"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "actions"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-raised-button", "", "matTooltip", "Delete", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Request confirmation", 3, "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Confirm", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Reject", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Delete", 3, "disabled", "click"], ["color", "warn"], ["mat-raised-button", "", "matTooltip", "Request confirmation", 3, "click"], ["color", "accent"], ["mat-raised-button", "", "matTooltip", "Confirm", 3, "disabled", "click"], ["mat-raised-button", "", "matTooltip", "Reject", 3, "disabled", "click"], [3, "click"]], template: function AttachmentTableComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵelementStart(1, "mat-toolbar", 1);
        i0.ɵɵprojection(2);
        i0.ɵɵelement(3, "mat-paginator", 2, 3);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(5, "mat-table", 4, 5);
        i0.ɵɵelementContainerStart(7, 6);
        i0.ɵɵtemplate(8, AttachmentTableComponent_mat_header_cell_8_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(9, AttachmentTableComponent_mat_cell_9_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(10, 9);
        i0.ɵɵtemplate(11, AttachmentTableComponent_mat_header_cell_11_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(12, AttachmentTableComponent_mat_cell_12_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(13, 10);
        i0.ɵɵtemplate(14, AttachmentTableComponent_mat_header_cell_14_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(15, AttachmentTableComponent_mat_cell_15_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(16, 11);
        i0.ɵɵtemplate(17, AttachmentTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(18, AttachmentTableComponent_mat_cell_18_Template, 3, 1, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(19, 12);
        i0.ɵɵtemplate(20, AttachmentTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(21, AttachmentTableComponent_mat_cell_21_Template, 3, 2, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(22, 13);
        i0.ɵɵtemplate(23, AttachmentTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(24, AttachmentTableComponent_mat_cell_24_Template, 2, 2, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵelementContainerStart(25, 14);
        i0.ɵɵtemplate(26, AttachmentTableComponent_mat_header_cell_26_Template, 3, 3, "mat-header-cell", 7);
        i0.ɵɵtemplate(27, AttachmentTableComponent_mat_cell_27_Template, 2, 2, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(28, AttachmentTableComponent_ng_container_28_Template, 3, 1, "ng-container", 15);
        i0.ɵɵelementContainerStart(29, 16);
        i0.ɵɵtemplate(30, AttachmentTableComponent_mat_header_cell_30_Template, 1, 0, "mat-header-cell", 17);
        i0.ɵɵtemplate(31, AttachmentTableComponent_mat_cell_31_Template, 5, 4, "mat-cell", 8);
        i0.ɵɵelementContainerEnd();
        i0.ɵɵtemplate(32, AttachmentTableComponent_mat_header_row_32_Template, 1, 0, "mat-header-row", 18);
        i0.ɵɵtemplate(33, AttachmentTableComponent_mat_row_33_Template, 1, 0, "mat-row", 19);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c0));
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("dataSource", ctx.dataSource);
        i0.ɵɵadvance(23);
        i0.ɵɵproperty("ngForOf", ctx.customColumns);
        i0.ɵɵadvance(4);
        i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [i3$1.DefaultLayoutAlignDirective, i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i5$1.MatTooltip, i7.BaseDateComponent, i8$1.CdkColumnDef, i8$1.CdkHeaderCellDef, i8$1.CdkCellDef, i8.NgIf, i11.MatButton, i4$1.MatIcon, i4.MatHeaderRow, i4.MatRow], pipes: [i12.TranslatePipe], encapsulation: 2 });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(AttachmentTableComponent, [{
        type: Component,
        args: [{
                selector: 'tracker-attachment-table',
                templateUrl: './attachment-table.component.html',
                styleUrls: [ /*'./attachment-table.component.scss'*/]
            }]
    }], function () { return [{ type: i1.AttachmentService, decorators: [{
                type: Inject,
                args: [forwardRef(() => AttachmentService)]
            }] }]; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], displayedActions: [{
            type: Input
        }], showFep: [{
            type: Input
        }], filter: [{
            type: Input
        }], dataSource: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }] }); })();

// modules
// services
class TrackerCompModule {
}
/** @nocollapse */ TrackerCompModule.ɵmod = i0.ɵɵdefineNgModule({ type: TrackerCompModule });
/** @nocollapse */ TrackerCompModule.ɵinj = i0.ɵɵdefineInjector({ factory: function TrackerCompModule_Factory(t) { return new (t || TrackerCompModule)(); }, providers: [], imports: [[
            CommonModule,
            FormsModule,
            ReactiveFormsModule,
            MatButtonModule,
            MatIconModule,
            MatRippleModule,
            MatSlideToggleModule,
            MatInputModule,
            MatTableModule,
            MatSortModule,
            MatTooltipModule,
            FlexLayoutModule,
            MatMenuModule,
            MatCheckboxModule,
            HttpClientModule,
            MatPaginatorModule,
            MatSelectModule,
            CdkTableModule,
            TranslateModule.forChild(),
            ChainBaseComp,
            MatDatepickerModule
        ]] });
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(TrackerCompModule, { declarations: [ProjectTableComponent,
        AddressComponent,
        AttachmentTableComponent,
        ProjectSheetTableComponent,
        RisksTableComponent,
        CustomFieldComponent,
        TemplateIdDirective], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        MatButtonModule,
        MatIconModule,
        MatRippleModule,
        MatSlideToggleModule,
        MatInputModule,
        MatTableModule,
        MatSortModule,
        MatTooltipModule,
        FlexLayoutModule,
        MatMenuModule,
        MatCheckboxModule,
        HttpClientModule,
        MatPaginatorModule,
        MatSelectModule,
        CdkTableModule, i12.TranslateModule, ChainBaseComp,
        MatDatepickerModule], exports: [ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent, CustomFieldComponent] }); })();
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(TrackerCompModule, [{
        type: NgModule,
        args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    ReactiveFormsModule,
                    MatButtonModule,
                    MatIconModule,
                    MatRippleModule,
                    MatSlideToggleModule,
                    MatInputModule,
                    MatTableModule,
                    MatSortModule,
                    MatTooltipModule,
                    FlexLayoutModule,
                    MatMenuModule,
                    MatCheckboxModule,
                    HttpClientModule,
                    MatPaginatorModule,
                    MatSelectModule,
                    CdkTableModule,
                    TranslateModule.forChild(),
                    ChainBaseComp,
                    MatDatepickerModule
                ],
                declarations: [
                    ProjectTableComponent,
                    AddressComponent,
                    AttachmentTableComponent,
                    ProjectSheetTableComponent,
                    RisksTableComponent,
                    CustomFieldComponent,
                    TemplateIdDirective
                ],
                exports: [
                    ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent, CustomFieldComponent
                ],
                providers: [],
                entryComponents: [],
                schemas: [CUSTOM_ELEMENTS_SCHEMA]
            }]
    }], null, null); })();

/*
 * Public API
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AddressComponent, AddressType, AttachmentTableComponent, AttachmentTableQueryStore, CustomFieldComponent, ProjectQueryStore, ProjectSheetQueryStore, ProjectSheetTableComponent, ProjectTableComponent, RisksTableComponent, RisksTableQueryStore, TrackerCompModule, addressTypes };
//# sourceMappingURL=yukawa-chain-tracker-angular-comp.js.map
