import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { Attachment, AttachmentFilter } from "@yukawa/chain-tracker-angular-core";
import { QueryResult } from "@yukawa/chain-base-angular-domain";
import { AttachmentAspect } from "@yukawa/chain-tracker-angular-core";
export declare class AttachmentTableQueryStore extends QueryTableSource<AttachmentFilter, Attachment> {
    protected service: AttachmentAspect;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: AttachmentFilter;
    constructor(service: AttachmentAspect, paginator?: MatPaginator, sort?: MatSort, tableFilter?: AttachmentFilter);
    protected queryTable(): Observable<QueryResult<Attachment>>;
}
