import { EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Attachment, AttachmentFilter } from "@yukawa/chain-tracker-angular-core";
import { AttachmentService } from "@yukawa/chain-tracker-angular-core";
import { FilteredTableSource } from "@yukawa/chain-base-angular-store";
import * as i0 from "@angular/core";
export declare class AttachmentTableComponent implements OnInit {
    private _service;
    displayedColumns: string[];
    customColumns: any[];
    displayedActions: any;
    showFep: boolean;
    filter: AttachmentFilter;
    dataSource: FilteredTableSource<AttachmentFilter, Attachment>;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    constructor(_service: AttachmentService);
    ngOnInit(): void;
    reload(): void;
    onAction(type: any, payload: any): void;
    isDisabled(action: string, row: Attachment): boolean;
    showAction(action: string, row: Attachment): boolean;
    showFepButton(action: string, row: Attachment): boolean;
    static ɵfac: i0.ɵɵFactoryDef<AttachmentTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<AttachmentTableComponent, "tracker-attachment-table", never, { "displayedColumns": "displayedColumns"; "customColumns": "customColumns"; "displayedActions": "displayedActions"; "showFep": "showFep"; "filter": "filter"; "dataSource": "dataSource"; }, { "action": "action"; }, never, ["*"]>;
}
