import { AfterContentInit, AfterViewInit, ChangeDetectorRef, OnInit, QueryList, TemplateRef } from '@angular/core';
import { CustomField } from "@yukawa/chain-tracker-angular-core";
import { TemplateIdDirective } from "./template-id.directive";
import { FormGroup } from "@angular/forms";
import * as i0 from "@angular/core";
export declare class CustomFieldComponent implements OnInit, AfterContentInit, AfterViewInit {
    private ref;
    customField: CustomField;
    customFieldTemplate: TemplateRef<any>;
    formGroup: FormGroup;
    templates: QueryList<TemplateIdDirective>;
    checkboxActive: boolean;
    options: Array<Object>;
    constructor(ref: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    onCheckBoxChange(event: any): void;
    initOptions(): void;
    static ɵfac: i0.ɵɵFactoryDef<CustomFieldComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<CustomFieldComponent, "chain-tracker-custom-field", never, { "customField": "customField"; "customFieldTemplate": "customFieldTemplate"; "formGroup": "formGroup"; }, {}, never, never>;
}
