import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { ProjectSheetQueryStore } from "./project-sheet-table-query.store";
import { ProjectSheetService } from "@yukawa/chain-tracker-angular-core";
import { ActivatedRoute } from '@angular/router';
import { ProjectSheet, ProjectSheetFilter } from "@yukawa/chain-tracker-angular-core";
import * as i0 from "@angular/core";
export declare class ProjectSheetTableComponent implements OnInit {
    private service;
    private _route;
    dataSource: ProjectSheetQueryStore;
    displayedColumns: string[];
    customColumns: any[];
    projectSheetFilter: ProjectSheetFilter;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    filter: ElementRef;
    constructor(service: ProjectSheetService, _route: ActivatedRoute);
    ngOnInit(): void;
    ngOnDestroy(): void;
    reload(keyword?: string): void;
    protected applyFilter(filter: ProjectSheetFilter): void;
    onAction(type: string, projectSheet: ProjectSheet | any): void;
    protected fireAction(action: any): void;
    static ɵfac: i0.ɵɵFactoryDef<ProjectSheetTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<ProjectSheetTableComponent, "chain-project-sheet-table", never, { "displayedColumns": "displayedColumns"; "customColumns": "customColumns"; "projectSheetFilter": "projectSheetFilter"; }, { "action": "action"; }, never, ["*"]>;
}
