import { QueryTableSource } from "@yukawa/chain-base-angular-store";
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { Observable } from "rxjs";
import { Risk } from "@yukawa/chain-tracker-angular-core";
import { RiskService } from "@yukawa/chain-tracker-angular-core";
import { EntityFilter } from "@yukawa/chain-base-angular-domain";
export declare class RisksTableQueryStore extends QueryTableSource<EntityFilter, Risk> {
    protected service: RiskService;
    protected paginator?: MatPaginator;
    protected sort?: MatSort;
    protected tableFilter?: EntityFilter;
    constructor(service: RiskService, paginator?: MatPaginator, sort?: MatSort, tableFilter?: EntityFilter);
    protected queryTable(): Observable<any>;
}
