import { EventEmitter, OnInit } from '@angular/core';
import { MatPaginator } from "@angular/material/paginator";
import { MatSort } from "@angular/material/sort";
import { RisksTableQueryStore } from "../risks-table-query.store";
import { RiskService } from "@yukawa/chain-tracker-angular-core";
import * as i0 from "@angular/core";
export declare class RisksTableComponent implements OnInit {
    private _riskService;
    displayedColumns: string[];
    customColumns: any[];
    projectId: string;
    dataSource: RisksTableQueryStore;
    action: EventEmitter<any>;
    paginator: MatPaginator;
    sort: MatSort;
    constructor(_riskService: RiskService);
    ngOnInit(): void;
    onAction(type: any, payload: any): void;
    deleteRisk(event: any): void;
    static ɵfac: i0.ɵɵFactoryDef<RisksTableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<RisksTableComponent, "chain-app-risks-table", never, { "displayedColumns": "displayedColumns"; "customColumns": "customColumns"; "projectId": "projectId"; "dataSource": "dataSource"; }, { "action": "action"; }, never, ["*"]>;
}
